Kea: isc::dhcp::PdPoolParser Class Reference

| Kea 3.2.0-git

isc::dhcp::PdPoolParser Class Reference

Parser for IPv6 prefix delegation definitions. More...

`#include <dhcp_parsers.h>`

Inheritance diagram for isc::dhcp::PdPoolParser:
[legend]

## Public Member Functions
| PdPoolParser ()
| Constructor.
virtual | ~PdPoolParser ()
| Virtual destructor.
void | parse (PoolStoragePtr pools, data::ConstElementPtr pd_pool_, bool encapsulate_options=true)
| Builds a prefix delegation pool from the given configuration.
Public Member Functions inherited from isc::data::SimpleParser
uint16_t | getUint16 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint16_t.
uint32_t | getUint32 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint32_t.
uint8_t | getUint8 (ConstElementPtr scope, const std::string &name)
| Get an uint8_t value.
const isc::util::Triplet< uint32_t > | parseIntTriplet (const data::ConstElementPtr &scope, const std::string &name)
| Parses an integer triplet.

## Protected Member Functions
virtual boost::shared_ptr< OptionDataListParser > | createOptionDataListParser () const
| Returns an instance of the `OptionDataListParser` to be used in parsing the option-data structure.
Protected Member Functions inherited from isc::data::SimpleParser
template<typename target_type, target_type convert>
target_type | getAndConvert (isc::data::ConstElementPtr scope, const std::string &name, const std::string &type_name)
| Returns a converted value from a scope.
template<typename int_type>
int_type | getIntType (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer value with range checking from a scope.

## Protected Attributes
isc::data::ConstElementPtr | client_class_
| Client class (a client has to belong to to use this pd-pool).
isc::dhcp::Pool6Ptr | pool_
| Pointer to the created pool object.
isc::data::ConstElementPtr | user_context_
| User context (optional, may be null).

## Additional Inherited Members
Static Public Member Functions inherited from isc::data::SimpleParser
static void | checkKeywords (const SimpleKeywords &keywords, isc::data::ConstElementPtr scope)
| Checks acceptable keywords with their expected type.
static void | checkRequired (const SimpleRequiredKeywords &required, isc::data::ConstElementPtr scope)
| Checks that all required keywords are present.
static size_t | deriveParams (isc::data::ConstElementPtr parent, isc::data::ElementPtr child, const ParamsList &params)
| Derives (inherits) parameters from parent scope to a child.
static isc::asiolink::IOAddress | getAddress (const ConstElementPtr &scope, const std::string &name)
| Returns a IOAddress parameter from a scope.
static bool | getBoolean (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a boolean parameter from a scope.
static double | getDouble (const ConstElementPtr &scope, const std::string &name)
| Returns a floating point parameter from a scope.
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer parameter from a scope.
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name, int64_t min, int64_t max)
| Returns an integer parameter from a scope and checks its range.
static const data::Element::Position & | getPosition (const std::string &name, const data::ConstElementPtr parent)
| Utility method that returns position of an element.
static std::string | getString (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a string parameter from a scope.
template<typename T>
static void | rangeCheckedInteger (isc::data::ConstElementPtr scope, const std::string &name, T &output_value)
| Fetches a range-checked integer parameter from a scope.
static size_t | setDefaults (isc::data::ElementPtr scope, const SimpleDefaults &default_values)
| Sets the default values.
static size_t | setListDefaults (isc::data::ConstElementPtr list, const SimpleDefaults &default_values)
| Sets the default values for all entries in a list.

## Detailed Description

Parser for IPv6 prefix delegation definitions.

This class handles prefix delegation pool definitions for IPv6 subnets Pool6 objects are created and stored in the given PoolStorage container.

PdPool definitions currently support three elements: prefix, prefix-len, and delegated-len, as shown in the example JSON text below:

{
"prefix": "2001:db8:1::",
"prefix-len": 64,
"delegated-len": 128
}

Definition at line 783 of file dhcp_parsers.h.

## Constructor & Destructor Documentation

## ◆ PdPoolParser()

isc::dhcp::PdPoolParser::PdPoolParser | ( |  | ) |

Constructor.

Definition at line 1103 of file dhcp_parsers.cc.

## ◆ ~PdPoolParser()

virtual isc::dhcp::PdPoolParser::~PdPoolParser | ( |  | ) |
| inlinevirtual

Virtual destructor.

Definition at line 791 of file dhcp_parsers.h.

## Member Function Documentation

## ◆ createOptionDataListParser()

boost::shared_ptr< OptionDataListParser > isc::dhcp::PdPoolParser::createOptionDataListParser | ( |  | ) | const
| protectedvirtual

Returns an instance of the `OptionDataListParser` to be used in parsing the option-data structure.

This function can be overridden in the child classes to supply a custom parser for option data.

Returns
  an instance of the `OptionDataListParser`.

Definition at line 1206 of file dhcp_parsers.cc.

Referenced by parse().

## ◆ parse()

void isc::dhcp::PdPoolParser::parse | ( | PoolStoragePtr | pools,
|  | data::ConstElementPtr | pd_pool_,
|  | bool | encapsulate_options = true )

Builds a prefix delegation pool from the given configuration.

This function parses configuration entries and creates an instance of a dhcp::Pool6 configured for prefix delegation.

Parameters

  pools | storage container in which to store the parsed pool.
  pd_pool_ | pointer to an element that holds configuration entries that define a prefix delegation pool.
  encapsulate_options | a boolean parameter indicating if the parsed options should be encapsulated with suboptions.

Exceptions

  DhcpConfigError | if configuration parsing fails.

Definition at line 1107 of file dhcp_parsers.cc.

References isc::dhcp::Pool::addAdditionalClass(), isc::dhcp::Pool::allowClientClass(), isc::data::SimpleParser::checkKeywords(), client_class_, createOptionDataListParser(), isc::dhcp::BaseNetworkParser::getAdditionalClassesElem(), isc::dhcp::BaseNetworkParser::getClientClassesElem(), isc::data::SimpleParser::getString(), isc::data::SimpleParser::getUint8(), isc_throw, isc::dhcp::SimpleParser6::PD_POOL6_PARAMETERS, pool_, and user_context_.

Here is the call graph for this function:

## Member Data Documentation

## ◆ client_class_

isc::data::ConstElementPtr isc::dhcp::PdPoolParser::client_class_
| protected

Client class (a client has to belong to to use this pd-pool).

If null, everyone is allowed.

Definition at line 832 of file dhcp_parsers.h.

Referenced by parse().

## ◆ pool_

isc::dhcp::Pool6Ptr isc::dhcp::PdPoolParser::pool_
| protected

Pointer to the created pool object.

Definition at line 822 of file dhcp_parsers.h.

Referenced by parse().

## ◆ user_context_

isc::data::ConstElementPtr isc::dhcp::PdPoolParser::user_context_
| protected

User context (optional, may be null).

User context is arbitrary user data, to be used by hooks.

Definition at line 827 of file dhcp_parsers.h.

Referenced by parse().

The documentation for this class was generated from the following files:

- dhcp_parsers.h
- dhcp_parsers.cc